package me.Demon.DemonWuDeng;


import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.inventory.ItemStack;

public class LampData {

    private final String LampKey;
    private final String CJQ_Lore;
    private final String CJQ_Name;
    private ItemStack item_1;
    private ItemStack item_2;
    private ItemStack item_3;
    private ItemStack item_4;
    private ItemStack item_5;
    private ItemStack item_6;

    private boolean start;
    private boolean wudeng2;
    private boolean wudeng3;
    private boolean wudeng4;
    private boolean wudeng5;

    private final int probnability_1;
    private final int probnability_2;
    private final int probnability_3;
    private final int probnability_4;
    private final int probnability_5;

    public LampData(String LampKey,FileConfiguration yml){
        this.LampKey = LampKey;
        String str = LampKey+".";
        this.CJQ_Name = yml.getString(str+"Paper_Name");
        this.CJQ_Lore = yml.getString(str+"Paper_Lore");

        this.item_1 = yml.getItemStack(str+"1_Reward");
        this.item_2 = yml.getItemStack(str+"2_Reward");
        this.item_3 = yml.getItemStack(str+"3_Reward");
        this.item_4 = yml.getItemStack(str+"4_Reward");
        this.item_5 = yml.getItemStack(str+"5_Reward");
        this.item_6 = yml.getItemStack(str+"6_Reward");

        this.probnability_1 = yml.getInt(str+"Probability."+"1");
        this.probnability_2 = yml.getInt(str+"Probability."+"2");
        this.probnability_3 = yml.getInt(str+"Probability."+"3");
        this.probnability_4 = yml.getInt(str+"Probability."+"4");
        this.probnability_5 = yml.getInt(str+"Probability."+"5");

    }

    public void saveLampData(FileConfiguration yml){
        String str = LampKey+".";
        yml.set(str+"1_Reward",item_1);
        yml.set(str+"2_Reward",item_2);
        yml.set(str+"3_Reward",item_3);
        yml.set(str+"4_Reward",item_4);
        yml.set(str+"5_Reward",item_5);
        yml.set(str+"6_Reward",item_6);

    }

    public String getLampKey() {
        return LampKey;
    }

    public String getCJQ_Name() {return CJQ_Name;}
    public String getCJQ_Lore() {return CJQ_Lore;}

    public boolean isStart() {return start;}
    public boolean isWudeng2() {return wudeng2;}
    public boolean isWudeng3() {return wudeng3;}
    public boolean isWudeng4() {return wudeng4;}
    public boolean isWudeng5() {return wudeng5;}

    public void setStart(boolean start) {this.start = start;}
    public void setWudeng2(boolean wudeng2) {this.wudeng2 = wudeng2;}
    public void setWudeng3(boolean wudeng3) {this.wudeng3 = wudeng3;}
    public void setWudeng4(boolean wudeng4) {this.wudeng4 = wudeng4;}
    public void setWudeng5(boolean wudeng5) {this.wudeng5 = wudeng5;}

    public ItemStack getReward_Item(int a){
        if(a == 2){
            return this.item_2;
        }else if(a == 3){
            return this.item_3;
        }else if(a == 4){
            return this.item_4;
        }else if(a == 5){
            return this.item_5;
        }else if(a == 6){
            return this.item_6;
        }else{
            return this.item_1;
        }
    }
    public void setReward_Item(int a,ItemStack items){
        if(a == 2){
            this.item_2 = items;
        }else if(a == 3){
            this.item_3 = items;
        }else if(a == 4){
            this.item_4 = items;
        }else if(a == 5){
            this.item_5 = items;
        }else if(a == 6){
            this.item_6 = items;
        }else{
            this.item_1 = items;
        }
    }

    public void setItem_1(ItemStack item_1) {this.item_1 = item_1;}
    public void setItem_2(ItemStack item_2) {this.item_2 = item_2;}
    public void setItem_3(ItemStack item_3) {this.item_3 = item_3;}
    public void setItem_4(ItemStack item_4) {this.item_4 = item_4;}
    public void setItem_5(ItemStack item_5) {this.item_5 = item_5;}
    public void setItem_6(ItemStack item_6) {this.item_6 = item_6;}

    public int getProbnability(int a){
        if(a == 2){
            return this.probnability_2;
        }else if(a == 3){
            return this.probnability_3;
        }else if(a == 4){
            return this.probnability_4;
        }else if(a == 5){
            return this.probnability_5;
        }else{
            return this.probnability_1;
        }
    }
}
