package me.Demon.DemonWuDeng;

import me.Demon.DemonWuDeng.GFCJJ.MachineAPI;
import me.Demon.DemonWuDeng.listener.SignClick;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static String prefix = "§7[§6战争领域§7] §f";
    public static List<String> getFile_Name = new ArrayList<>();
    public static HashMap<String,MachineData> MachineAPI = new HashMap<>();
    public static HashMap<String,LampData> DataAPI = new HashMap<>();

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        getFile_Name.addAll(Load_FileName_List());
        Load_MachineData_or_LampData();
        Bukkit.getConsoleSender().sendMessage("§e[DemonWuDeng] §r载入抽奖方案["+DataAPI.size()+"]");
        Bukkit.getConsoleSender().sendMessage("§e[DemonWuDeng] §r载入抽奖机["+MachineAPI.size()+"]");
        Bukkit.getServer().getPluginManager().registerEvents(new SignClick(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new MachineAPI(), plugin);
        Bukkit.getConsoleSender().sendMessage("§e[DemonWuDeng] §r正在启动插件...");
    }

    public static void Load_MachineData_or_LampData(){
        for (String File_Name : getFile_Name) {
            File file = new File("plugins/DemonWuDeng/配置方案", File_Name+".yml");
            FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
            DataAPI.put(File_Name,new LampData(File_Name,yml));
            MachineAPI.put(File_Name,new MachineData(File_Name,yml));
        }
    }

    @Override
    public void onDisable() {
        SaveLampData();
        Bukkit.getConsoleSender().sendMessage("§e[DemonWuDeng] §r正在关闭插件...");
    }

    public void SaveLampData(){
        int a = 0;
        for (String Lamp_key : DataAPI.keySet()) {
            File file = new File("plugins/DemonWuDeng/配置方案", Lamp_key+".yml");
            YamlConfiguration yml = YamlConfiguration.loadConfiguration(file);
            DataAPI.get(Lamp_key).saveLampData(yml);
            saveFileConfig(yml,file);
            a++;
        }
        Bukkit.getConsoleSender().sendMessage("§e[DemonWuDeng] §r保存抽奖数据["+a+"]个");
    }

    public boolean onCommand (CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("wudeng") && sender.isOp()) {
            if(args.length == 1 && args[0].equalsIgnoreCase("save")){
                SaveLampData();
                sender.sendMessage(prefix+"数据保存成功.");
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("reload")){
                getFile_Name.clear();
                MachineAPI.clear();
                DataAPI.clear();
                getFile_Name.addAll(Load_FileName_List());
                Load_MachineData_or_LampData();
                sender.sendMessage(prefix+"配置文件重载完成.");
            }
        }
        return false;
    }

    public static List<String> Load_FileName_List(){
        List<String> list = new ArrayList<>();
        File plans = new File("./plugins/DemonWuDeng", "配置方案");
        File[] files = plans.listFiles();
        File[] arrayOfFile1;
        int j = (Objects.requireNonNull(arrayOfFile1 = files)).length;
        for (int i = 0; i < j; i++) {
            File s = arrayOfFile1[i];
            String file_Name = s.getName().replace(".yml","");
            list.add(file_Name);
        }
        return list;
    }

    public static void saveFileConfig(YamlConfiguration yml,File file){ try { yml.save(file); }catch (IOException e){e.printStackTrace();} }
}
