package me.Demon.DemonWuDeng.listener;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonWuDeng.GFCJJ.LampAPI;
import me.Demon.DemonWuDeng.LampData;
import me.Demon.DemonWuDeng.Main;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class SignClick implements Listener {


    @EventHandler
    public void onclick_sign(PlayerInteractEvent e) {
        Player p = e.getPlayer();
        if (e.getAction() != Action.RIGHT_CLICK_BLOCK) {
            return;
        }
        if (e.getClickedBlock().getState() instanceof Sign) {
            Sign s = (Sign) e.getClickedBlock().getState();
            if (s.getLine(0).equalsIgnoreCase("§a§l[五灯抽奖机]")) {
                String lamp_type = s.getLine(2).replace("§7", "");
                LampData dataAPI = Main.DataAPI.get(lamp_type);
                if (dataAPI == null) {
                    p.sendMessage(Main.prefix + "该五灯抽奖机已停止维护.");
                    p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
                    return;
                }
                if (dataAPI.isStart()) {
                    p.sendMessage(Main.prefix + "§f五灯抽奖机正在冷却中...");
                    p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                    return;
                }
                ItemStack item = p.getInventory().getItemInHand();
                boolean butt = false;
                if (!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item) && item.getType() == Material.PAPER) {
                    ItemMeta meta = item.getItemMeta();
                    if (meta.getDisplayName().equalsIgnoreCase(dataAPI.getCJQ_Name())) {
                        if (meta.getLore().contains(dataAPI.getCJQ_Lore())) {
                            butt = true;
                        }
                    }
                }
                if (butt) {
                    // 扣除抽奖券
                    if (item.getAmount() == 1) {
                        p.getInventory().setItemInHand(new ItemStack(Material.AIR));
                    } else {
                        item.setAmount(item.getAmount() - 1);
                    }
                    dataAPI.setStart(true);
                    LampAPI.Start_Event(dataAPI);
                } else {
                    p.sendMessage(Main.prefix + "§f请手持" + dataAPI.getCJQ_Name() + "§f再尝试右键木牌.");
                    p.playSound(p.getLocation(), Sound.ENTITY_VILLAGER_NO, 1, 2);
                }
            }
        }
    }

}
