package me.Demon.DemonWuDeng.GFCJJ;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonWuDeng.LampData;
import me.Demon.DemonWuDeng.Main;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.scheduler.BukkitRunnable;

public class MachineAPI implements Listener {

    public static void Spawner_DropItems(LampData dataAPI, int a){
        if(a == 5){
            if(DemonAPI.getRandomInt(1000,1) >= 500){
                a = 6;
            }
        }
        ItemStack item = dataAPI.getReward_Item(a);
        if(DemonAPI.itemIsNull(item)){
            return;
        }
        int amount = dataAPI.getReward_Item(a).getAmount();
        if(amount <= 1){
            return;
        }
        World world = Bukkit.getWorld("wudeng");
        if(world == null) {
            return;
        }
        String Lamp_Key = dataAPI.getLampKey();
        Location drop_loc = Main.MachineAPI.get(Lamp_Key).getDrop_loc(a);

        ItemStack drop_items = item.clone();
        drop_items.setAmount(1);
        world.dropItem(drop_loc, drop_items);

        ItemStack new_items = item.clone();
        new_items.setAmount(item.getAmount() - 1);
        dataAPI.setReward_Item(a,new_items);
    }

    public static void Spawner_RedBlock(LampData dataAPI, int a){
        World world = Bukkit.getWorld("wudeng");
        if(world == null) {
            return;
        }
        String Lamp_Key = dataAPI.getLampKey();
        Location block_Loc = Main.MachineAPI.get(Lamp_Key).getBlock_loc(a);
        Block block = block_Loc.getBlock();
        block.setType(Material.REDSTONE_BLOCK);
        new BukkitRunnable() {
            public void run() {
                block.setType(Material.AIR);
            }
        }.runTaskLater(Main.plugin, 40L);
    }
}
