package me.Demon.DemonWuDeng;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.configuration.file.FileConfiguration;

public class MachineData {
    private final String MachineKey;
    private final Location drop_loc1;
    private final Location drop_loc2;
    private final Location drop_loc3;
    private final Location drop_loc4;
    private final Location drop_loc5;
    private final Location block_loc1;
    private final Location block_loc2;
    private final Location block_loc3;
    private final Location block_loc4;
    private final Location block_loc5;

    public MachineData(String MachineKey,FileConfiguration yml){
        this.MachineKey = MachineKey;
        this.drop_loc1 = getLoadDataLoc("Drop_Items",1,yml);
        this.drop_loc2 = getLoadDataLoc("Drop_Items",2,yml);
        this.drop_loc3 = getLoadDataLoc("Drop_Items",3,yml);
        this.drop_loc4 = getLoadDataLoc("Drop_Items",4,yml);
        this.drop_loc5 = getLoadDataLoc("Drop_Items",5,yml);

        this.block_loc1 = getLoadDataLoc("RedStone_Block",1,yml);
        this.block_loc2 = getLoadDataLoc("RedStone_Block",2,yml);
        this.block_loc3 = getLoadDataLoc("RedStone_Block",3,yml);
        this.block_loc4 = getLoadDataLoc("RedStone_Block",4,yml);
        this.block_loc5 = getLoadDataLoc("RedStone_Block",5,yml);
    }

    public Location getLoadDataLoc(String type,int a,FileConfiguration yml){
        String drop_str = MachineKey+"."+type;
        double x = yml.getDouble(drop_str+"."+a+".x");
        double y = yml.getDouble(drop_str+"."+a+".y");
        double z = yml.getDouble(drop_str+"."+a+".z");
        return new Location(Bukkit.getWorld("wudeng"),x,y,z);
    }

    public Location getBlock_loc(int a) {
        if(a == 2) {
            return block_loc2;
        }else if(a == 3) {
            return block_loc3;
        }else if(a == 4) {
            return block_loc4;
        }else if(a == 5) {
            return block_loc5;
        }
        return block_loc1;
    }

    public Location getDrop_loc(int a) {
        if(a == 2) {
            return drop_loc2;
        }else if(a == 3) {
            return drop_loc3;
        }else if(a == 4) {
            return drop_loc4;
        }else if(a == 5) {
            return drop_loc5;
        }
        return drop_loc1;
    }

}
